'From Smalltalk-80 of December 6, 1982 on 1 January 1980 at 4:44:12 am'!


!Macintosh methodsFor: 'QuickDraw Calls'!
addPt: srcPt dstPt: dstPt
	"adds coords of srcPt to dstPt and returns result in dstPt" 

	<primitive: 160 trapA: 16rC7E type: '--PVP'>
	^self primitiveFailed!
backPat: pat
	"set the background pattern of the currrent grafport to pat" 

	<primitive: 160 trapA: 16rC7C type: '--D'>
	^self primitiveFailed!
clipRect: r
	"set clipping region of current grafport to r" 

	<primitive: 160 trapA: 16rC7B type: '--R'>
	^self primitiveFailed!
closePicture
	"close the picture" 

	<primitive: 160 trapA: 16rCF4 type: '--'>
	^self primitiveFailed!
closePoly
	"close a polygon" 

	<primitive: 160 trapA: 16rCCC type: '--'>
	^self primitiveFailed!
closePort: gp
	"close the port gp" 

	<primitive: 160 trapA: 16rC7D type: '--D'>
	^self primitiveFailed!
closeRgn: dstRgn
	"save newly defined region in dstRgn" 

	<primitive: 160 trapA: 16rCDB type: '--H'>
	^self primitiveFailed!
copyBits: srcBits dstBits: dstBits srcRect: srcRect dstRect: dstRect mode: mode maskRgn: maskRgn
	"CopyBits transfers a bit image between any two bitMaps and clips the result to the area specified by the masskRgn parameter." 

	<primitive: 160 trapA: 16rCEC type: '--DDRRIH'>
	^self primitiveFailed!
copyRgn: srcRgn dstRgn: dstRgn
	"copy source region into dest region" 

	<primitive: 160 trapA: 16rCDC type: '--HH'>
	^self primitiveFailed!
diffRgn: srcRgnA srcRgnB: srcRgnB dstRgn: dstRgn
	"returns dstRgn as srcRgnA - srcRgnB" 

	<primitive: 160 trapA: 16rCE6 type: '--HHH'>
	^self primitiveFailed!
disposeRgn: rgn
	"dispose of rgn" 

	<primitive: 160 trapA: 16rCD9 type: '--H'>
	^self primitiveFailed!
drawPicture: myPicture dstRect: dstRect
	"draw mypicture within dstrect" 

	<primitive: 160 trapA: 16rCF6 type: '--HR'>
	^self primitiveFailed!
drawString: s
	"draw the string s" 

	<primitive: 160 trapA: 16rC84 type: '--S'>
	^self primitiveFailed!
emptyRgn: rgn
	"returns True if rgn is empty" 

	<primitive: 160 trapA: 16rCE2 type: 'B-H'>
	^self primitiveFailed!
equalPt: ptA ptB: ptB
	"retrun true if ptA = ptB" 

	<primitive: 160 trapA: 16rC81 type: 'B-PP'>
	^self primitiveFailed!
equalRect: a rectB: b 
	"return true if a = b" 

	<primitive: 160 trapA: 16rCA6 type: 'B-RR'>
	^self primitiveFailed!
equalRgn: rgnA rgnB: rgnB
	"returns True if rgnA = rgnB" 

	<primitive: 160 trapA: 16rCE3 type: 'B-HH'>
	^self primitiveFailed!
eraseArc: r startAngle: startAngle arcAngle: arcAngle
	"QD fillArc" 

	<primitive: 160 trapA: 16rCC0 type: '--RII'>
	^self primitiveFailed!
eraseOval: r 
	"draw a hollow oval just inside the rectangle r using current grafport's pattern, mode and size" 

	<primitive: 160 trapA: 16rCB9 type: '--R'>
	^self primitiveFailed!
erasePoly: poly
	"erase a polygon" 

	<primitive: 160 trapA: 16rCC8 type: '--H'>
	^self primitiveFailed!
eraseRect: r 
	"paint the rectangle r with the current grafPort's background pattern" 

	<primitive: 160 trapA: 16rCA3 type: '--R'>
	^self primitiveFailed!
eraseRgn: rgn
	"erase rgn with current grafports background color" 

	<primitive: 160 trapA: 16rCD4 type: '--H'>
	^self primitiveFailed!
eraseRoundRect: r ovalWidth: ovalWidth ovalHeight: ovalHeight
	"Qd eraseRoundRect" 

	<primitive: 160 trapA: 16rCB2 type: '--RII'>
	^self primitiveFailed!
fillArc: r startAngle: startAngle arcAngle: arcAngle
	"QD fillArc" 

	<primitive: 160 trapA: 16rCC2 type: '--RII'>
	^self primitiveFailed!
fillArc: r startAngle: startAngle arcAngle: arcAngle pat: pat
	"QD fillArc" 

	<primitive: 160 trapA: 16rCC2 type: '--RIID'>
	^self primitiveFailed!
fillOval: r pat:  pat 
	"fills r with the pattern pat" 

	<primitive: 160 trapA: 16rCBB type: '--RD'>
	^self primitiveFailed!
fillPoly: poly pat: pat
	"fill a polygon with pat" 

	<primitive: 160 trapA: 16rCCA type: '--HD'>
	^self primitiveFailed!
fillRect: r pat:  pat 
	"fills r with the pattern pat" 

	<primitive: 160 trapA: 16rCA5 type: '--RD'>
	^self primitiveFailed!
fillRgn: rgn pat: pat
	"fill rgn with pattern pat" 

	<primitive: 160 trapA: 16rCD6 type: '--HD'>
	^self primitiveFailed!
fillRoundRect: r ovalWidth: ovalWidth ovalHeight: ovalHeight pat: pat
	"QD fillRoundRect" 

	<primitive: 160 trapA: 16rCB4 type: '--RIID'>
	^self primitiveFailed!
frameArc: r startAngle: startAngle arcAngle: arcAngle
	"QD fillArc" 

	<primitive: 160 trapA: 16rCBE type: '--RII'>
	^self primitiveFailed!
frameOval: r 
	"draw a hollow oval just inside the rectangle r using current grafport's pattern, mode and size" 

	<primitive: 160 trapA: 16rCB7 type: '--R'>
	^self primitiveFailed!
framePoly: poly
	"frame a polygon" 

	<primitive: 160 trapA: 16rCC6 type: '--H'>
	^self primitiveFailed!
frameRect: r 
	"draw a hollow outline just inside the rectangle r using current grafport's pattern, mode and size" 

	<primitive: 160 trapA: 16rCA1 type: '--R'>
	^self primitiveFailed!
frameRgn: rgn
	"frame rgn" 

	<primitive: 160 trapA: 16rCD2 type: '--H'>
	^self primitiveFailed!
frameRoundRect: r ovalWidth: ovalWidth ovalHeight: ovalHeight
	"QD frameRoundRect" 

	<primitive: 160 trapA: 16rCB0 type: '--RII'>
	^self primitiveFailed!
getClip: rgn
	"get current clipping region" 

	<primitive: 160 trapA: 16rC7A type: '--H'>
	^self primitiveFailed!
getPen: pt
	"get the pen location" 

	<primitive: 160 trapA: 16rC9A type: '--VP'>
	^self primitiveFailed!
getPort: gp
	"get the port gp" 

	<primitive: 160 trapA: 16rC74 type: '--VD'>
	^self primitiveFailed!
globalToLocal: pt
	"convert pt from global coords to local coords" 

	<primitive: 160 trapA: 16rC71 type: '--VP'>
	^self primitiveFailed!
hideCursor
	"hide the cursor" 

	<primitive: 160 trapA: 16rC52 type: '--'>
	^self primitiveFailed!
hidePen
	"hide the pen" 

	<primitive: 160 trapA: 16rC96 type: '--'>
	^self primitiveFailed!
initCursor
	"init the cursor" 

	<primitive: 160 trapA: 16rC50 type: '--'>
	^self primitiveFailed!
initGraf: globalPtr
	"init QuickDraw" 

	<primitive: 160 trapA: 16rC6E type: '--D'>
	^self primitiveFailed!
initPort: gp
	"init the port gp" 

	<primitive: 160 trapA: 16rC6D type: '--D'>
	^self primitiveFailed!
insetRect: r dh: h dv: v 
	"shrink or expand r by h and v" 

	<primitive: 160 trapA: 16rCA9 type: '--VRII'>
	^self primitiveFailed!
insetRgn: rgn dh: dh dv: dv
	"shrinks rgn, does not effect screen till you redraw the region" 

	<primitive: 160 trapA: 16rCE1 type: '--HII'>
	^self primitiveFailed!
invertArc: r startAngle: startAngle arcAngle: arcAngle
	"QD fillArc" 

	<primitive: 160 trapA: 16rCC1 type: '--RII'>
	^self primitiveFailed!
invertRect: r 
	"inverts all pixels enclosed by r" 

	<primitive: 160 trapA: 16rCA4 type: '--R'>
	^self primitiveFailed!
invertRgn: rgn
	"invert all bits within rgn" 

	<primitive: 160 trapA: 16rCD5 type: '--H'>
	^self primitiveFailed!
killPicture: myPicture
	"dispose of mypicture" 

	<primitive: 160 trapA: 16rCF5 type: '--H'>
	^self primitiveFailed!
killPoly: poly
	"kill a polygon" 

	<primitive: 160 trapA: 16rCCD type: '--H'>
	^self primitiveFailed!
line: dh dv: dv
	"draw a line from current pen location to the location that is the distance
	dh and dv from the current location." 

	<primitive: 160 trapA: 16rC92 type: '--II'>
	^self primitiveFailed!
lineTo: h v: v
	"draw a line from current pen location to the location specified (in local coordinates) by h and 	v." 

	<primitive: 160 trapA: 16rC91 type: '--II'>
	^self primitiveFailed!
localToGlobal: pt
	"convert pt from local coords to global coords" 

	<primitive: 160 trapA: 16rC70 type: '--VP'>
	^self primitiveFailed!
move: dh dv: dv
	"move pen h,v in the current grafport without drawing" 

	<primitive: 160 trapA: 16rC94 type: '--II'>
	^self primitiveFailed!
moveTo: h v: v
	"move pen to h,v in the current grafport without drawing" 

	<primitive: 160 trapA: 16rC93 type: '--II'>
	^self primitiveFailed!
newRgn
	"allocate space and return handle for a new region" 

	<primitive: 160 trapA: 16rCD8 type: 'H-'>
	^self primitiveFailed!
offsetPoly: poly dh: dh dv: dv
	"offset a polygon by dh and dv" 

	<primitive: 160 trapA: 16rCCE type: '--HII'>
	^self primitiveFailed!
offsetRect: r dh: h dv: v 
	"move rectangle r by adding h to each horizontal coord and v to each vertical coord" 

	<primitive: 160 trapA: 16rCA8 type: '--VRII'>
	^self primitiveFailed!
offsetRgn: rgn dh: dh dv: dv
	"moves rgn, does not effect screen till you redraw the region" 

	<primitive: 160 trapA: 16rCE0 type: '--HII'>
	^self primitiveFailed!
openPicture: picFrame
	"open a picture" 

	<primitive: 160 trapA: 16rCF3 type: 'H-R'>
	^self primitiveFailed!
openPoly
	"open a polygon and return its handle" 

	<primitive: 160 trapA: 16rCCB type: 'H-'>
	^self primitiveFailed!
openPort: gp
	"open the port gp" 

	<primitive: 160 trapA: 16rC6F type: '--D'>
	^self primitiveFailed!
openRgn
	"start saving info for region definition" 

	<primitive: 160 trapA: 16rCDA type: '--'>
	^self primitiveFailed!
paintArc: r startAngle: startAngle arcAngle: arcAngle
	"QD fillArc" 

	<primitive: 160 trapA: 16rCBF type: '--RII'>
	^self primitiveFailed!
paintOval: r 
	"draw a hollow oval just inside the rectangle r using current grafport's pattern, mode and size" 

	<primitive: 160 trapA: 16rCB8 type: '--R'>
	^self primitiveFailed!
paintPoly: poly
	"erase a polygon" 

	<primitive: 160 trapA: 16rCC7 type: '--H'>
	^self primitiveFailed!
paintRect: r 
	"paint the rectangle r with the current grafPort's pen pattern and mode" 

	<primitive: 160 trapA: 16rCA2 type: '--R'>
	^self primitiveFailed!
paintRgn: rgn
	"paint rgn with current grafports pen pattern and pen mode" 

	<primitive: 160 trapA: 16rCD3 type: '--H'>
	^self primitiveFailed!
paintRoundRect: r ovalWidth: ovalWidth ovalHeight: ovalHeight
	"QD frameRoundRect" 

	<primitive: 160 trapA: 16rCB1 type: '--RII'>
	^self primitiveFailed!
penMode: mode 
	"set the pen mode" 

	<primitive: 160 trapA: 16rC9C type: '--I'>
	^self primitiveFailed!
penNormal
	"set initial state of the pen in the current grafport" 

	<primitive: 160 trapA: 16rC9E type: '--'>
	^self primitiveFailed!
penPat: pat 
	"set the pen pattern" 

	<primitive: 160 trapA: 16rC9D type: '--D'>
	^self primitiveFailed!
penSize: width height: height
	"set the pen width and height" 

	<primitive: 160 trapA: 16rC9B type: '--II'>
	^self primitiveFailed!
pt2Rect: ptA ptB: ptB dstRect: dstRect 
	"return smallest rectangle enclosing points a and b" 

	<primitive: 160 trapA: 16rCAC type: '--PPVR'>
	^self primitiveFailed!
ptInRect: pt r: r
	"see if pt is within r" 

	<primitive: 160 trapA: 16rCAD type: 'B-PR'>
	^self primitiveFailed!
ptInRgn: pt rgn: rgn
	"returns True if pt is in rgn" 

	<primitive: 160 trapA: 16rCE8 type: 'B-PH'>
	^self primitiveFailed!
ptToAngle: r pt: pt angle: angle 
	"Calculate an integer angle, angle, between a line from the center of the rectangle, r, to the given point , pt, and a line from the center of the rectangle pointing straight up." 

	<primitive: 160 trapA: 16rCC3 type: '--RPVI'>
	^self primitiveFailed!
random
	"generate a random integer" 

	<primitive: 160 trapA: 16rC61 type: 'I-'>
	^self primitiveFailed!
rectInRgn: r rgn: rgn
	"returns True if r intersects rgn by at least one point" 

	<primitive: 160 trapA: 16rCE9 type: 'B-RH'>
	^self primitiveFailed!
rectRgn: rgn r: r
	"set rgn to the rectangle r" 

	<primitive: 160 trapA: 16rCDF type: '--HR'>
	^self primitiveFailed!
scrollRect: r dh: dh dv: dv upDateRgn: upDateRgn 
	"shifts (dh horizontally and dv vertically) those bits inside the intersection of r, visRgn, clipRgn, portRect and portBits.bounds.  upDateRgn is changed to the area filled with bkPat" 

	<primitive: 160 trapA: 16rCEF type: '--RIIH'>
	^self primitiveFailed!
sectRect: srcA srcB: srcB dstRect: dstRect
	"intersect a and b to produce r" 

	<primitive: 160 trapA: 16rCAA type: 'B-RRVR'>
	^self primitiveFailed!
sectRgn: srcRgnA srcRgnB: srcRgnB dstRgn: dstRgn
	"returns dstRgn as intersection of srcRgnA and srcRgnB" 

	<primitive: 160 trapA: 16rCE4 type: '--HHH'>
	^self primitiveFailed!
setClip: rgn
	"set current clipping region" 

	<primitive: 160 trapA: 16rC79 type: '--H'>
	^self primitiveFailed!
setCursor: crsr
	"set current cursor to crsr" 

	<primitive: 160 trapA: 16rC51 type: '--D'>
	^self primitiveFailed!
setEmptyRgn: rgn
	"set rgn to the empty region" 

	<primitive: 160 trapA: 16rCDD type: '--H'>
	^self primitiveFailed!
setPort: gp
	"set the port gp" 

	<primitive: 160 trapA: 16rC73 type: '--D'>
	^self primitiveFailed!
setPortBits: bm
	"set the port bits to bm" 

	<primitive: 160 trapA: 16rC75 type: '--D'>
	^self primitiveFailed!
setPt: pt h: h v: v
	"set point pt to h and v" 

	<primitive: 160 trapA: 16rC80 type: '--VPII'>
	^self primitiveFailed!
setRect: r L: left T: top R: right B: bottom
	"set the rectangle r using left, top, right and bottom" 

	<primitive: 160 trapA: 16rCA7 type: '--VRIIII'>
	^self primitiveFailed!
setRectRgn: rgn L: left T: top R: right B: bottom
	"set rgn to set rgn to the rectangle left, top, right, bottom" 

	<primitive: 160 trapA: 16rCDE type: '--HIIII'>
	^self primitiveFailed!
showCursor
	"hide the cursor" 

	<primitive: 160 trapA: 16rC53 type: '--'>
	^self primitiveFailed!
showPen
	"show the pen" 

	<primitive: 160 trapA: 16rC97 type: '--'>
	^self primitiveFailed!
stringWidth: s
	"retrun width of string s" 

	<primitive: 160 trapA: 16rC8C type: 'I-S'>
	^self primitiveFailed!
stuffHex: thingPtr s: s
	"copy hex stuff pointed to by thingPtr into s" 

	<primitive: 160 trapA: 16rC66 type: '--DS'>
	^self primitiveFailed!
subPt: srcPt dstPt: dstPt
	"subtracts coords of srcPt from dstPt and returns result in dstPt" 

	<primitive: 160 trapA: 16rC7F type: '--PVP'>
	^self primitiveFailed!
textFace: face
	"set text face of current grafport to face" 

	<primitive: 160 trapA: 16rC88 type: '--I'>
	^self primitiveFailed!
textFont: font
	"set text font of current grafport to font" 

	<primitive: 160 trapA: 16rC87 type: '--I'>
	^self primitiveFailed!
textMode: mode
	"set the current grafport's mode to mode" 

	<primitive: 160 trapA: 16rC89 type: '--I'>
	^self primitiveFailed!
textSize: size
	"set the current grafport's size to size" 

	<primitive: 160 trapA: 16rC8A type: '--I'>
	^self primitiveFailed!
unionRect: srcA srcB: srcB dstRect: dstRect
	"union a and b to produce r" 

	<primitive: 160 trapA: 16rCAB type: '--RRVR'>
	^self primitiveFailed!
unionRgn: srcRgnA srcRgnB: srcRgnB dstRgn: dstRgn
	"returns dstRgn as union of srcRgnA and srcRgnB" 

	<primitive: 160 trapA: 16rCE5 type: '--HHH'>
	^self primitiveFailed!
xorRgn: srcRgnA srcRgnB: srcRgnB dstRgn: dstRgn
	"returns dstRgn as difference between union and intersection of srcRgnA and srcRgnB" 

	<primitive: 160 trapA: 16rCE7 type: '--HHH'>
	^self primitiveFailed! !